*****************************************************************************
*																			*
* 	Replikation Preiinger & Meyer (2015): Einstellungszugnglichkeit 		*
*	im Laufe von Wahlkmpfen. PVS Sonderheft Politische Psychologie			*
*																			*
*****************************************************************************

/*
Hier: Master-Dofile, gesamtes Projekt besteht aus mehreren Einzeldofiles.
Master-Dofile informiert ber Abfolge der Einzeldofiles und fhrt sie, wenn
gewnscht, nacheinander aus.
*/		
	

clear

cd "/Replikationsmaterialien"			//Verzeichnis festlegen

* Verwendete Packages
//ssc install fre
//ssc install fsum
//ssc install estout
//ssc install grc1leg

*-------------------------------------------------------------
* Analyse mit bestmglicher Messung Zugnglichkeit (Artikel)
*------------------------------------------------------------

* Fr jedes Jahr getrennt: Datenmodifikationen
run 2005\2005_mod.do
run 2005\2005_latenzen.do
run 2009\2009_mod.do
run 2009\2009_latenzen.do
run 2013\2013_mod.do
run 2013\2013_latenzen.do

* modifizierte Einzeljahresdatenstze zusammenspielen
use 2005/2005.dta, clear
append using 2009/2009.dta
append using 2013/2013.dta

save "alle Jahre zusammen/allyears.dta", replace

* Analyse mit Gesamtjahresadtensatz
do "alle Jahre zusammen/analysis"


*------------------------------------------------------------------------------
* Analyse mit am besten vergleichbaren Messung Zugnglichkeit (Robustheitstest)
*------------------------------------------------------------------------------

clear

* Fr jedes Jahr getrennt: Datenmodifikationen
run 2005\2005_mod.do
run 2005\2005_latenzen.do
run 2009\2009_mod.do
run 2009\2009_latenzen_dirty.do
run 2013\2013_mod.do
run 2013\2013_latenzen_dirty.do

* modifizierte Einzeljahresdatenstze zusammenspielen
use 2005/2005.dta, clear
append using 2009/2009_dirty.dta
append using 2013/2013_dirty.dta

save "alle Jahre zusammen/allyears_dirty.dta", replace

* Analyse mit Gesamtjahresdatensatz
do "alle Jahre zusammen/analysis_dirty"
